
/**
 * ǿ ä ʴ
 * */

import org.kwis.msp.lcdui.*;
import org.kwis.msp.lwc.*;
import java.awt.event.ActionEvent;
import org.kwis.msf.io.*;
import java.io.*;
import java.io.IOException;
import java.util.Vector;


public class StandbyUserList implements CommandListener, ActionListener
{
    private byte SelectedKey = (byte)-1; //ListComponent õ Ű
    private String SelectedId = ""; //ListComponent õ  ̵

    private ShellComponent sh = null;
    private FormComponent center = null;
    private FormComponent south = null;

//    private Image img=null, img=null, imgʴ=null, imgȭ=null, imgäôڸ=null;
    private Image img_before=null, img_next=null, img_request=null, img_to_chatting_room=null, img_all_name_of_waitting_room_person=null;
//    private String strCmd="", strCmd="", strCmdʴ="ʴ", strCmdȭ="ȭ";
    private String strCmd_before="", strCmd_next="", strCmd_request="ʴ", strCmd_to_chatting_room="ȭ";
//    private Command cmd=null, cmd=null, cmdʴ=null, cmdȭ=null;
    private Command cmd_before=null, cmd_next=null, cmd_request=null, cmd_to_chatting_room=null;

    private ClientUnit m_network = null; //Ŭ̾Ʈ Ʈp 
    private Vector m_buffer = new Vector();
    private ListComponent m_list = null;
    private String m_roomTitle = null; //äù


    /**
     * 
     * */
    private StandbyUserList(){}

    /**
     * 
     *
     * @param sh 
     * @param unit Ʈp
     * @param roomTitle äù
     * */
    public StandbyUserList(ShellComponent sh, ClientUnit unit, String roomTitle)
    {
      this.sh = sh;
      this.m_network = unit;
      m_roomTitle = roomTitle;
      center = new FormComponent(true);//Horizon Layout
      south = new FormComponent(true);//Horizon Layout

      //ҽ ʱȭ
      imageLoading();//̹ ε

      //Ŀǵ  Ҷ  Ʈ  
      sh.removeAllComponents();

      load();

      //Ʈp ɿ ˻ Ʈp   ˸â
      if (!m_network.isEnable()) m_network.showErrorDlg("Ʈũ !");
    }

    /**
     *  Ŀǵ带 εѴ
     * */
	private final void load()
    {
      //̺ 
      LabelComponent label = new LabelComponent("", img_all_name_of_waitting_room_person);
      label.setBackground(0x336699);
      label.setForeground(0x396CB6);
      sh.setTitle(label);

      //ڸ
      m_list = new ListComponent(ListComponent.SELECT_IMPLICIT);
      m_list.controlNumber(false);
      center.addComponent(m_list);

      //command bar
      CommandBarComponent cmdBar = new CommandBarComponent();
      cmdBar.addCommand(cmd_before = new Command(strCmd_before, img_before, strCmd_before));
      cmdBar.addCommand(cmd_next = new Command(strCmd_next, img_next, strCmd_next));
      cmdBar.addCommand(cmd_request = new Command(strCmd_request, img_request, strCmd_request));
      cmdBar.addCommand(cmd_to_chatting_room = new Command(strCmd_to_chatting_room, img_to_chatting_room, strCmd_to_chatting_room));
      cmdBar.setCommandListener(this, null);
      south.addComponent(cmdBar);

      // ̱
      sh.addComponent(center);
      sh.setCommand(south, false);
      sh.show();
	}

    //ä  Ʈ ϱ
    public final void setStandbyUserList(Vector buf)
    {
      this.m_buffer = buf;

      if (m_buffer.size() > 0)
      {
        for (int i=0; i<m_buffer.size(); i++)
        {
          ChatUser user = (ChatUser)m_buffer.elementAt(i);
          String id = user.getUserId();
          int serial = user.getUserSerial();
          m_list.append(id, null);
        }

        //ù° Ҹ ׻ ϰ ִ
        m_list.select(0);
        m_list.setActionListener(this, m_list);
      }
      else
        m_list.append(" ڰ ϴ !", null);
    }

    /**
     * png غ
     * */
    private final boolean imageLoading()
    {
      try
      {
        img_before = Image.createImage("bott_chati02.png");
        img_next = Image.createImage("bott_chati03.png");
        img_request = Image.createImage("bott_chati07.png");
        img_to_chatting_room = Image.createImage("bott_chati09.png");
        img_all_name_of_waitting_room_person = Image.createImage("title_chat05.png");
      }
      catch(Exception e){ return false; }

      return true;
    }

  /**
   * CommandBar ̺Ʈ ó
   * */
  public void commandAction(Command c, int type, Object obj)
  {
    if (m_network.isEnable())
    {
      String cmd = c.getString();

      if (type == 2)
      {
        if (cmd.equalsIgnoreCase(strCmd_before))
        {
          System.out.println("..");
        }
        else if (cmd.equalsIgnoreCase(strCmd_next))
        {
          System.out.println("..");
        }
        //ʴ  ȭ 
        else if (cmd.equalsIgnoreCase(strCmd_request))
        {
          String id = SelectedId;
          byte key = SelectedKey;
          System.out.println(id+", serial="+key+"  ʴմϴ !");

          if (id != null && !id.equalsIgnoreCase(""))
          {
            // ʴ޼ 
            m_network.invite(m_network.room_number,
                                  m_network.Id,
                                  ProtocolInterface.STANDBY_ROOM, id,
                                  key);
            Chat chatting_room = new Chat(sh, m_network, this.m_network.room_number, m_roomTitle);
          }
        }
        //äù
        else if (cmd.equalsIgnoreCase(strCmd_to_chatting_room))
        {
          Chat chatting_room = new Chat(sh, m_network, this.m_network.room_number, m_roomTitle);
        }
      }
    }
  }

  /**
   * ListComponent ׼ ó
   * */
  public void action(Component c, Object o)
  {
    if (m_network.isEnable())
    {
      ListComponent list = (ListComponent)o;
      //Ʈ õ ε 
      int selectedIdx = list.getSelectedIndex();
      // õ ä 
      ChatUser user = (ChatUser)m_buffer.elementAt(selectedIdx);
      SelectedId = user.getUserId();
      SelectedKey = user.getUserSerial();

      //For Debugging
      //System.out.println(SelectedId+"   "+SelectedKey+" Ű ִ!");
    }
  }

}
