import java.io.*;
import java.util.Vector;
import org.kwis.msp.lwc.*;
import org.kwis.msf.io.*;
import java.io.*;

/**
 * <p>Title: Ŭ̾Ʈ Ʈp </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class ClientUnit implements ProtocolInterface
{
  //Ʈp Ǻ
  private Socket m_soc = null;
  private boolean m_isAlive = false; //ä ޼ б   
  private boolean m_isServiceEnable = false; //Ʈp  Ȱȭ 
  private ReadStream m_reader = null; //б Ʈ
  private WriteStream m_writer = null; // Ʈ
  private InputStream m_is = null; // Ʈ
  private OutputStream m_os = null; // Ʈ
  private Thread m_chatThread = null; //ä б 
  private String m_ip = null; //ּ
  private int m_port = -1; //Ʈ
  //Ŭ̾Ʈ 
//  public String ̵ = "";
  public String Id = "";
//  public byte ȣ = (byte)0;
  public byte user_number = (byte)0;
//  public byte ȣ = (byte)0;
  public byte room_number = (byte)0;
  //ä  
  private Chat m_chat = null;
  private StandbyRoom m_stChat = null;
  private NewRoom m_newRoom = null;
  private StandbyUser m_stUser = null;


  /**
   * 
   * */
  public ClientUnit()
  {
  }

  /**
   * Ʈp ɿ
   *
   * @return boolean ɿ
   * */
  public final boolean isEnable()
  {
    return m_isServiceEnable;
  }

  /**
   *  äù ȣ 
   *
   * @return byte ȣ
   * */
  public final byte getUserSerial()
  {
    return user_number;
  }

  /**
   *  äù ȣ 
   *
   * @return byte äù ȣ
   * */
  public final byte getChatRoomId()
  {
    return room_number;
  }

  /**
   *  ̵ 
   *
   * @param id ̵
   * */
  public final void setUserId(String id)
  {
    Id = id;
  }

  /**
   *  ̵ 
   *
   * @return id ̵
   * */
  public final String getUserId()
  {
    return Id;
  }

  /**
   * TestClient  
   *
   * @return boolean ۰
   * */
  public boolean startService(String ip, int port, String userId)
  {
    this.m_ip = ip;
    this.m_port = port;
    this.Id = userId;
    m_isServiceEnable = true;
    try
    {
      int ret = Network.connect();

      if (ret != -1)
      {
        m_soc = URL.find("socket://"+m_ip.trim()+":"+String.valueOf(m_port));
        m_is = m_soc.getInputStream();
        m_os = m_soc.getOutputStream();
        m_reader = new ReadStream(m_is);
        m_writer = new WriteStream(m_os);
      }
      else
      {
        m_isServiceEnable = false;
        return false;
      }
    }
    catch(Exception e)
    {
      m_isServiceEnable = false;
      return false;
    }

    return true;
  }

  /**
   * TestClient  
   *
   * @return boolean Լ
   * */
  public final boolean stopService()
  {
    try
    {
      this.m_isAlive = false;
      m_isServiceEnable = false;

      if (this.m_soc != null) this.m_soc.close();
      this.m_soc = null;

      if (this.m_reader != null) this.m_reader.close();
      this.m_reader = null;

      if (this.m_writer != null) this.m_writer.close();
      this.m_writer = null;
    }
    catch(Exception e){}

    return true;
  }

  /**
   * ä  ޼ б  
   * */
  public final boolean startChatReader(NewRoom newRoom, Chat chat, StandbyRoom stChat, StandbyUser stUser)
  {
    this.m_newRoom = newRoom;
    this.m_chat = chat;
    this.m_stChat = stChat;
    this.m_stUser = stUser;

    //̹ ۵Ǿ ִٸ  ʴ´
    if (m_isAlive == true) return false;

    this.m_isAlive = true;

    try
    {
      m_chatThread = new Thread(new Runnable()
      {
        public void run()
        {
          try
          {
            while(m_isAlive)
            {
              byte major = m_reader.readByte();
              byte minor = m_reader.readByte();
              byte service = m_reader.readByte();

              switch(service)
              {
                case LOGIN :
                    byte loginRet = m_reader.readByte(); // : 0x01 , 0x00 οʰ, 0x10 ̵ߺ
                    byte loginRoomNo = m_reader.readByte(); //ȣ
                    byte loginUserNo = m_reader.readByte(); //ȣ
                    user_number = loginUserNo;
                    room_number = loginRoomNo;
                    //â ̺Ʈ ߻Ű
                    if (m_stUser != null)
                        m_stUser.loadStandbyRoom(loginRet);
                  break;

                case MAKE_CHATROOM :
                    byte mkRoomRet = m_reader.readByte(); // : 0x01 , 0x00|0x10 
                    if (m_newRoom != null)
                        m_newRoom.showMakeChatRoomResult(mkRoomRet);
                    break;

                //äù Ʈ 
                case GET_CHATROOM_LIST :
                    byte rooms = m_reader.readByte(); //氹
                    Vector buf = new Vector();
                    for (int i=0; i<(int)rooms; i++)
                    {
                      byte roomNo = m_reader.readByte(); //ȣ
                      String roomTitle = m_reader.readString(); //
                      byte maxUser = m_reader.readByte(); //ִ ο
                      String passwd = m_reader.readString(); //ȣ

                      buf.addElement(String.valueOf(roomNo));
                      buf.addElement(roomTitle);
                      buf.addElement(String.valueOf(maxUser));
                      buf.addElement(passwd);
                    }
                  //â ޼ ֱ
                  if (m_stChat != null)
                      m_stChat.setChatRoomList(buf);
                   break;

              case CHAT_LOGIN :
                   byte chLoginResult = m_reader.readByte(); // : 0x01 , 0x00 
                   byte chLoginNo = m_reader.readByte(); //äù ȣ
                   byte chLoginRoomNo = m_reader.readByte(); //äù ȣ
                   if (chLoginNo != -1)
                   {
                     user_number = chLoginNo;
                     room_number = chLoginRoomNo;

                     //ä â ֱ
                     if (m_stChat != null)
                         m_stChat.enterChatRoom();
                   }
                   else
                   {
                     //ä â ֱ
                     if (m_stChat != null)
                         m_stChat.showLoginFailDlg();
                   }
                   break;

                //äø޼ б
                case SEND_MESSAGE :
                    byte chatroomNo = m_reader.readByte(); //äù ȣ
                    byte usrNo = m_reader.readByte();      // ȣ
                    String usrId = m_reader.readString();  // ̵
                    String usrMsg = m_reader.readString(); // ޼
                    //â ޼ ֱ
                    if (m_chat != null)
                        m_chat.setMsg(usrId, usrMsg);
                    break;

                //äù濡 α׾ƿ
                case CHAT_LOGOUT :
                    byte ret = m_reader.readByte(); // 0x01
                    byte newUserNo = m_reader.readByte(); // ο ȣ
                    //
                    user_number = newUserNo;
                    room_number = STANDBY_ROOM;
                    break;

                //ä Ʈ 
                case GET_CHATROOM_USER_LIST :
                    byte no = m_reader.readByte(); //Ѱ
                    Vector ctUserBuf = new Vector();
                    for(int i=0; i<(int)no; i++)
                    {
                      String id = m_reader.readString(); //̵
                      String serial = m_reader.readString(); //ȣ

                      ctUserBuf.addElement(id);
                      ctUserBuf.addElement(serial);
                    }
                    //â ޼ ֱ
                    if (m_chat != null)
                        m_chat.setChatUserList(ctUserBuf);
                    break;

                //äù泻 ٸ α׾ƿ ˸
                case CHATUSER_LOGOUT :
                    byte userNo = m_reader.readByte(); //ȣ
                    String userId = m_reader.readString(); //̵
                    //â ޼ ֱ
                    if (m_chat != null)
                        m_chat.setMsg(userId, "α׾ƿ!");
                    break;

                //äù泻 ٸ α ˸
                case ALARM_CHATUSER_LOGIN :
                    byte alNo = m_reader.readByte(); //ȣ
                    String alId = m_reader.readString(); //̵
                    //â ޼ ֱ
                    if (m_chat != null)
                        m_chat.setMsg(alId, "!");
                    break;

                  //äô Ʈ ֱ
                  case GET_STANDBY_USER_LIST :
                    byte stNo = m_reader.readByte(); //Ѱ
                    Vector stBuf = new Vector();
                    for(int i=0; i<(int)stNo; i++)
                    {
                      String id = m_reader.readString(); //̵
                      String serial = m_reader.readString(); //ȣ
                      stBuf.addElement(new ChatUser(id, serial));
                    }
                    //â ޼ ֱ
                    if (m_chat != null)
                        m_chat.setStandbyUserList(stBuf);
                    break;

                  // Ư  û ޼  ˸  
                  case INVITE :
                    byte inviteRet = m_reader.readByte(); //濡 û û 

                    //ʴâ äâ ۵Ǵ  ʴ뼺/ θ ˷ټ 
                    /*
                    if (inviteRet == (byte)1)
                    {
                      System.out.println("[ʴϱ] ۿϷ!");
                      //â ޼ ֱ
                      if (m_chat != null)
                          m_chat.setMsg(̵, "ʴϷ!..........");
                    }
                    else
                    {
                      System.out.println("[ʴϱ] ۽!");
                      //â ޼ ֱ
                        if (m_chat != null)
                         m_chat.setMsg(̵, "ʴ!");
                    }
                    */
                    break;

                  //û ޼ ˸ !
                  case INVITE_MESSAGE :
                    byte inviteRoomNo = m_reader.readByte();//ʴ ȣ
                    String inviteUserId = m_reader.readString();//ʴ ̵
                    String inviteTitle = m_reader.readString();//ʴ 
                    byte invitedRoomNo = m_reader.readByte();//ʴ   ȣ
                    byte invitedUserNo = m_reader.readByte();//ʴ   ȣ
                    //â ޼ ֱ
                    String msg = "'"+inviteTitle+"' 濡 "+inviteUserId+" ʴ߽ϴ!";
                    if (m_stChat != null)
                        m_stChat.showInviteMessage(inviteRoomNo);
                    break;

                // α׾ƿ  
                case EXIT_ROOM_USER :
                  stopService(); //, Ʈp
                  break;

                case REJECT_INVITE_MESSAGE :
                  getRejectMessage();
                  break;

                default :
                  System.out.println("ClientUnit.run().Unknown Message = "+service);
                  break;
              }
            }
          }
          catch(Exception e)
          {
             System.out.println("ClientUnit.run().Reading Error ="+e.toString());
          }
          stopChatReader();
        }
      });
      m_chatThread.start();
    }
    catch(Exception e)
    {
      System.out.println("ClientUnit.run().Reader Startup Error ="+e.toString());
      return false;
    }

    return true;
  }

  /**
   * ä  ޼ б  
   * */
  public final void stopChatReader()
  {
    m_isAlive = false;
  }

  /**
   * äù濡 α׾ƿ  Ƿ 
   *
   * @return boolean α׾ƿ 
   * */
  public final void chat_logout()
  {
    try
    {
      //
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      WriteStream w = new WriteStream(baos);
      w.writeByte(this.room_number);
      w.writeByte(this.user_number);
      w.writeString(this.Id);
      //
      this.sendFrame(CHAT_LOGOUT, baos.toByteArray());
      baos.close(); baos = null;
      w.close(); w = null;
    }
    catch(IOException ioe)
    {
      System.out.println("chat_logout().ioe = "+ioe.toString());
      this.stopChatReader();
    }
  }

  /**
   * (äô) α
   *
   *  @return byte [result]
   *        0: α 
   *        1: α 
   * */
  public final void login(String id)
  {
    try
    {
      //
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      WriteStream w = new WriteStream(baos);
      w.writeString(id);
      sendFrame(LOGIN, baos.toByteArray());
      baos.close(); baos = null;
      w.close(); w = null;
    }
    catch(Exception e)
    {
      System.out.println("login() e = "+e.toString());
    }
  }

  /**
   *  äù Ʈ 䱸
   * */
  public final void get_chatroom_list()
  {
    try
    {
      //
      sendFrame(GET_CHATROOM_LIST, new byte[0]);
    }
    catch(Exception e)
    {
      System.out.println("get_chatroom_list() e = "+e.toString());
    }
  }

  /**
   *  äù 
   * */
  public final void make_chatroom(byte _number, String _room_name, String _pass)
  {
    try
    {
      //
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      WriteStream w = new WriteStream(baos);
      w.writeByte((byte)_number); //ο
      w.writeString(_room_name); //
      w.writeByte(SECURITY_ROOM); ///
      w.writeString(_pass); //ȣ

      sendFrame(MAKE_CHATROOM, baos.toByteArray());
      baos.close(); baos = null;
      w.close(); w = null;
    }
    catch(Exception e)
    {
      System.out.println("make_chatroom e = "+e.toString());
    }
  }

  /**
   * äù濡 α
   * */
  public final void chat_login(byte _enter_room_number)
  {
    try
    {
      //
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      WriteStream w = new WriteStream(baos);
      w.writeString(this.Id); //̵);
      w.writeByte(_enter_room_number);
      w.writeByte(this.user_number); //ȣ);
      sendFrame(CHAT_LOGIN, baos.toByteArray());
      baos.close(); baos = null;
      w.close(); w = null;
    }
    catch(IOException e)
    {
      System.out.println("chat_login() e = "+e.toString());
    }
  }

  /**
   *    Ʈ 䱸
   * */
  public final void get_standby_user_list()
  {
    try
    {
      //
      sendFrame(GET_STANDBY_USER_LIST, new byte[0]);
    }
    catch(IOException e)
    {
      System.out.println("get_standby_user_list() e = "+e.toString());
    }
  }

  /**
   *  Ư äù  Ʈ 䱸
   * */
  public final void get_chatroom_user_list()
  {
    try
    {
      //
      byte[] retAry = new byte[1];
      retAry[0] = this.room_number;
      sendFrame(GET_CHATROOM_USER_LIST, retAry);
    }
    catch(IOException e)
    {
      System.out.println("get_chatroom_user_list e = "+e.toString());
    }
  }

  /**
   * ޼ 
   * */
  public final void message(String _message)
  {
    try
    {
      //
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      WriteStream w = new WriteStream(baos);
      w.writeByte(room_number);
      w.writeByte(user_number);
      w.writeString(Id);
      w.writeString(_message);
      sendFrame(SEND_MESSAGE, baos.toByteArray());
      baos.close(); baos = null;
      w.close(); w = null;
    }
    catch(IOException ioe)
    {
      if (m_chat != null)
          m_chat.setMsg(Id, "޼ ۽!");
    }
  }

  /**
   * ޼ 
   * */
  public final void message(byte _room_number, byte _user_number, String _user_id, String _message) throws IOException
  {
    //
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    WriteStream w = new WriteStream(baos);
    w.writeByte(_room_number);
    w.writeByte(_user_number);
    w.writeString(_user_id);
    w.writeString(_message);
    sendFrame(SEND_MESSAGE, baos.toByteArray());
    baos.close(); baos = null;
    w.close(); w = null;
  }

  /**
   * Ư (, äù ) ä 
   * (α׷ )
   * */
  public final void exit_room_user()
  {
    try
    {
      //
      byte[] body = new byte[0];
      sendFrame(EXIT_ROOM_USER, body);
    }
    catch(IOException e)
    {
       System.out.println("exit_room_user() e = "+e.toString());
    }

    Id = "";
    user_number = (byte)0;
    room_number = (byte)0;
  }

  /**
   *  äù   
   * */
  private final void destroy_chatroom(byte room_number) throws IOException
  {
    //
    ByteArrayOutputStream baos = new ByteArrayOutputStream();
    WriteStream w = new WriteStream(baos);
    w.writeByte(room_number);
    sendFrame(DESTROY_CHATROOM, baos.toByteArray());
    baos.close(); baos = null;
    w.close(); w = null;
  }

  /**
   * äô  Ư äù ʴ
   * */
  public final void invite(byte _request_room_number, String _request_id, byte _request_user_room_number, String _request_source_id, byte _request_dest_user_number)
  {
    try
    {
      //
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      WriteStream w = new WriteStream(baos);
      w.writeByte(_request_room_number);
      w.writeString(_request_id);
      w.writeByte(_request_user_room_number);
      w.writeString(_request_source_id);
      w.writeByte(_request_dest_user_number);
      sendFrame(INVITE, baos.toByteArray());
      baos.close(); baos = null;
      w.close(); w = null;
    }
    catch(IOException e)
    {
      System.out.println("invite() e = "+e.toString());
    }
  }

  /**
   * ʴ ޼ 
   * */
  private final void getRejectMessage()
  {
    try
    {
      String userId = m_reader.readString();
      //â ޼ ֱ
      if (m_chat != null)
          m_chat.setMsg(userId, "ʴ!");
    }
    catch(IOException ioe) {}
  }

  /**
   * ʴ ޼ 
   *
   * @param roomNo ʴ ޼  ȣ
   * */
  public final void sendRejectMessage(byte roomNo)
  {
    try
    {
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      WriteStream w = new WriteStream(baos);
      w.writeByte(roomNo);
      w.writeString(Id);
      //
      sendFrame(REJECT_INVITE_MESSAGE, baos.toByteArray());
      baos.close(); baos = null;
      w.close(); w = null;
    }
    catch(IOException e)
    {
      System.out.println("sendRejectMessage() e = "+e.toString());
    }
  }

  /**
   * 䱸 
   *
   * @param service  а
   *      (: LOGIN, SEND_MESSAGE  ProtocolInterface ǵȰ)
   * @param body[] 
   * */
  private final void sendFrame(byte service, byte body[]) throws IOException
  {
    m_writer.writeByte(MAJOR_VER);
    m_writer.writeByte(MINOR_VER);
    m_writer.writeByte(service);

    if (body.length > 0)
      m_writer.write(body, 0, body.length);

    m_writer.flush();
  }


  //Ʈp  ̾α ֱ
  public final void showErrorDlg(String msg)
  {
    DialogComponent caution = new DialogComponent(
                   new LabelComponent(msg),
                  "",
                  DialogComponent.TYPE_NONE);
    caution.setTimeout(1*1000);
    caution.show();
  }

  //ä б   ˾Ƴ
  public final boolean isChatReaderEnable()
  {
    return m_isAlive;
  }

}