/**
 * ä
 * */

import org.kwis.msp.lcdui.*;
import org.kwis.msp.lwc.*;
import java.awt.event.ActionEvent;
import org.kwis.msf.io.*;
import java.io.*;
import java.io.IOException;
import java.util.Vector;


public class Chat implements EventListener
{
    private int SelectedKey = -1; //äù ȣ
    private String SelectedTitle = ""; //äù 

    private ShellComponent sh = null;
    private FormComponent center = null;
    private FormComponent south = null;

    private CyementTextField m_tfInput = null; //ѹ ۽Ű   40 byte 
    private TextBoxComponent m_tbArea = null; //300byte ̻ ũѽ ȭ Clear Ų
//    private Image imgä = null;
    private Image img_chatting = null;
    private ClientUnit m_network = null; //Ŭ̾Ʈ Ʈp 
    private ChatMenu m_menu = null; //äø޴
    private boolean m_isCommandMode = false; //äø޴ ȭ ƴ ϴ , -7( )  ۵ȴ


    /**
     * 
     * */
    private Chat(){}

    /**
     * 
     *
     * @param sh 
     * @param unit Ʈp
     * @param roomNo äùȣ
     * @param title äù
     * */
    public Chat(ShellComponent sh, ClientUnit unit, int roomNo, String title)
    {
      this.m_network = unit;
      this.sh = sh;
      this.SelectedKey = roomNo;
      this.SelectedTitle = title;

      center = new FormComponent(true);//Horizon Layout
      south = new FormComponent(true);//Horizon Layout

      //ҽ ʱȭ
      imageLoading();//̹ ε

      //Ŀǵ  Ҷ  Ʈ  
      sh.removeAllComponents();

      load();

      //Ʈp ɿ ˻ Ʈp   ˸â
      if (!m_network.isEnable()) m_network.showErrorDlg("Ʈũ !");

      if (m_network.isEnable()) m_network.startChatReader(null, this, null, null);
    }

    /**
     * ä  Ʈ ֱ
     *
     * @param buf ä Ʈ
     * */
    public final void setChatUserList(Vector buf)
    {
      if (m_menu != null)
      {
          m_menu.setChatUserList(buf);
      }
    }

    /**
     *  Ʈ ֱ
     *
     * @param buf  Ʈ
     * */
    public final void setStandbyUserList(Vector buf)
    {
      if (m_menu != null)
      {
        m_menu.setStandbyUserList(buf);
      }
    }

    /**
     *  Ŀǵ带 εѴ
     * */
	private final void load()
    {
        //ҽ ʱȭ
        m_tfInput = null;
        m_tbArea = null;

        //̺ 
        LabelComponent lbTitle = new LabelComponent(SelectedTitle, img_chatting);
        lbTitle.setBackground(0x000066);
        lbTitle.setForeground(0xFFFFFF);
        sh.setTitle(lbTitle);

        //äó ֱ â
        m_tbArea = new TextBoxComponent(null, TextComponent.CONSTRAINT_ANY, 7);
        m_tbArea.setForeground(0x003366);
        center.addComponent(m_tbArea);

        //Էʵ
        m_tfInput = new CyementTextField(null, TextComponent.CONSTRAINT_ANY);
        m_tfInput.setForeground(0x003366);
        m_tfInput.setMaxLength(40);
        south.addComponent(m_tfInput);

        //۹ư
        m_menu = new ChatMenu(sh, this, this.m_network, this.SelectedTitle);
        this.m_menu.setEventListener(this, null);

        sh.addComponent(center);
        sh.setCommand(south, false);
        sh.show();
        south.setFocus(m_tfInput); //Էâ Ŀ α
        this.m_tfInput.setEventListener(this, null);
	}

    /**
     * png غ
     * */
    private final boolean imageLoading()
    {
      try
      {
        img_chatting = Image.createImage("title_chat07.png");
      }
      catch(Exception e){ return false; }

      return true;
    }

  /**
   * textfield event ó
   * */
  public boolean eventNotify(int type, int arg1, int arg2, int arg3, Object obj)
  {
    if (m_network.isEnable())
    {
      if (arg1 == 1 && type == Component.KEY_NOTIFY)
      {
        if (arg2 == -5)
        {
          String msg = m_tfInput.getString();
          msg = msg.trim();

          if (msg.equalsIgnoreCase("x")) //ä, äôǷ ư
          {
            // äù α׾ƿ ˸
            m_network.chat_logout();
            //äôǷ 
            StandbyRoom room = new StandbyRoom(sh, this.m_network);
          }
          else
          {
            // ޼  ( ޼  ʴ´)
            if (!msg.trim().equalsIgnoreCase(""))
                m_network.message(msg);
          }
        }
        else if (arg2 == -7)
        {
          if (m_isCommandMode)//ɾ , ȭԷâ  ȯ
          {
            changeInputMode();
          }
          else //ȭԷâ  ɾ  ȯ
          {
            changeCommandMode();
          }
        }

        return true;
      }
    }

    return false;
  }

  /**
   *  ȭԷâ  ȯ (ɾ ǰ)
   * */
  public final void changeInputMode()
  {
    south.removeAllComponents();
    south.addComponent(m_tfInput);
    south.setFocus(m_tfInput); //Էâ Ŀ α
    m_isCommandMode = false;
  }

  /**
   * ɾ  ȯ (ȭԷâ ǰ)
   * */
  public final void changeCommandMode()
  {
    south.removeAllComponents();
    south.addComponent(m_menu);
    m_isCommandMode = true;
  }

  /**
   * ޼ ֱ
   * */
  public final void setMsg(String usrId, String msg)
  {
    //TextArea 300Ʈ ̻  Ŭ Ŵ
    byte[] contents = m_tbArea.getString().getBytes();
    if (contents.length > 300) m_tbArea.setString("");

    String preMsg = m_tbArea.getString();
    msg = "["+usrId+"]"+msg+"\n";

    if (preMsg.equalsIgnoreCase(""))
        preMsg = msg;
    else
        preMsg = msg + preMsg;

    m_tbArea.setString("");
    m_tbArea.setString(preMsg);

    // TextField   ۾. (Wipi)
    m_tfInput.setString("");
  }

}

/**
 * Chat Ǵ ۸޴
 * */
class ChatMenu extends FormComponent implements CommandListener
{
//  private String strCmdʴ="ʴ", strCmdں="ں", strCmdȭ="ȭ";
  private String strCmd_request="ʴ", strCmd_room_people="ں", strCmd_to_room="ȭ";
//  private Image imgʴ=null, imgں=null, imgȭ=null;
  private Image img_request=null, img_room_people=null, img_to_room=null;
//  private Command cmdʴ=null, cmdں=null, cmdȭ=null;
  private Command cmd_request=null, cmd_room_people=null, cmd_to_room=null;
  private ShellComponent sh = null;
  private ClientUnit m_network = null; //Ŭ̾Ʈ Ʈp 
//  private ShowChatUserList ä = null; //ä 
  private ShowChatUserList chatting_attandance = null; //ä 
//  private StandbyUserList äô = null; //äô 
  private StandbyUserList chatting_waitting = null; //äô 
  private String m_roomTitle = null; //
  private Chat m_chat = null;


  /**
   * 
   * */
  private ChatMenu() {}

  /**
   * 
   *
   * @param sh 
   * @param chat Chat
   * @param unit Ʈp
   * @param title äù
   * */
  ChatMenu(ShellComponent sh, Chat chat, ClientUnit unit, String title)
  {
    super(true);

    this.m_chat = chat;
    this.m_network = unit;
    this.sh = sh;
    m_roomTitle = title;

    imageLoading(); //̹ ε

    //command bar
    CommandBarComponent cmdBar = new CommandBarComponent();
    cmdBar.addCommand(cmd_request = new Command(this.strCmd_request, img_request, null));
    cmdBar.addCommand(cmd_room_people = new Command(this.strCmd_room_people, img_room_people, null));
    cmdBar.addCommand(cmd_to_room = new Command(this.strCmd_to_room, img_to_room, null));

    cmdBar.setCommandListener(this, null);

    addComponent(cmdBar);

    //Ʈp ɿ ˻ Ʈp   ˸â
    if (!m_network.isEnable()) m_network.showErrorDlg("Ʈũ !");
  }

  /**
   * png غ
   * */
  private final boolean imageLoading()
  {
    try
    {
      img_request = Image.createImage("bott_chati07.png");
      img_room_people = Image.createImage("bott_chati08.png");
      img_to_room = Image.createImage("bott_chati09.png");
    }
    catch(Exception e){ return false; }

    return true;
  }

  /**
   * CommandBar ̺Ʈ ó
   * */
  public void commandAction(Command c, int type, Object obj)
  {
    if (m_network.isEnable())
    {
      String cmd = c.getString();

      if (type == 2)
      {
        //äô 濡 äô ʴ
        if (cmd.equalsIgnoreCase(strCmd_request))
        {
          chatting_waitting = new StandbyUserList(sh, this.m_network, m_roomTitle);
          //ä Ʈ û
          if (m_network.isEnable())
              m_network.get_standby_user_list();
        }
        // äô濡 äô Ʈ 
        else if (cmd.equalsIgnoreCase(strCmd_room_people))
        {
          chatting_attandance = new ShowChatUserList(sh, this.m_network, m_roomTitle);
          //ä Ʈ û
          if (m_network.isEnable())
              m_network.get_chatroom_user_list();
        }
        //ȭ ư
        else if (cmd.equalsIgnoreCase(strCmd_to_room))
        {
          Chat chatting = new Chat(sh, this.m_network, this.m_network.room_number, this.m_roomTitle);
        }
      }
    }
  }

  /**
   * ä Ʈ ֱ
   *
   * @param buf ä Ʈ
   * */
  public final void setChatUserList(Vector buf)
  {
    if (chatting_attandance != null)
       chatting_attandance.setChatUserList(buf);
  }

  /**
   * äô Ʈ ֱ
   * @param äô Ʈ
   * */
  public final void setStandbyUserList(Vector buf)
  {
    if (chatting_waitting != null)
       chatting_waitting.setStandbyUserList(buf);
  }

}

