
/**
 * ä 
 * */

import org.kwis.msp.lcdui.*;
import org.kwis.msp.lwc.*;
import java.awt.event.ActionEvent;
import org.kwis.msf.io.*;
import java.io.*;
import java.io.IOException;
import java.util.*;


public class StandbyRoom implements CommandListener, ActionListener
{
//    private Vector Bufäô = new Vector(); //ChatRoom 
    private Vector Buf_waitting_room = new Vector(); //ChatRoom 
    private int SelectedKey = -1; //ListComponent õ ο ȣ  (ChatRoom.m_key ش)
    private String SelectedTitle = ""; //ListComponent õ 
    private String SelectedPasswd = "";//ListComponent õ äù ȣ
    private boolean SelectedInvite = false; //ListComponent õ äù ʴ濩
    private int IsOpen = -1; //ListComponent õ äù 

    private ShellComponent sh = null;
    private FormComponent center = null;
    private FormComponent south = null;

//    private String strCmd="", strCmd="", strCmdäù="äù",
//          strCmd氳="氳", strCmd="", strCmd="",
//          strCmd="", strCmdäô="äô";
    private String strCmd_before="", strCmd_next="", strCmd_enter_chatting_room="äù",
          strCmd_make_room="氳", strCmd_exit="", strCmd_open_room="",
          strCmd_close_room="", strCmd_waitting_room="äô";
//    private Image img=null, img=null, imgäù=null, img氳=null, img=null,
//          img=null, img=null, imgäô=null,
//          imgʴ = null;
    private Image img_before=null, img_next=null, img_enter_chatting_room=null, img_make_room=null, img_exit=null,
          img_open_room=null, img_close_room=null, img_waitting_room=null,
          img_request_room = null;
//    private Command cmd=null, cmd=null, cmdäù=null, cmd氳=null, cmd=null;
    private Command cmd_before=null, cmd_next=null, cmd_enter_chatting_room=null, cmd_make_room=null, cmd_exit=null;

    private ClientUnit m_network = null; //Ŭ̾Ʈ Ʈp 
    private ListComponent m_list = null;


    /**
     * 
     * */
    private StandbyRoom(){}

    /**
     * 
     *
     * @param sh 
     * @param unit Ʈp
     * */
    public StandbyRoom(ShellComponent sh, ClientUnit unit)
    {
      this.m_network = unit;
      this.sh = sh;
      center = new FormComponent(true);//Horizon Layout
      south = new FormComponent(false);//Vertical Layout

      // ǹ Ƿ ʱȭ
      m_network.room_number = ProtocolInterface.STANDBY_ROOM;

      //ҽ ʱȭ
      imageLoading();//̹ ε

      //Ŀǵ  Ҷ  Ʈ  
      sh.removeAllComponents();

      if (m_network.isEnable())
         m_network.startChatReader(null, null, this, null);

      load();

      this.m_network.get_chatroom_list();

      //Ʈp ɿ ˻ Ʈp   ˸â
      if (!m_network.isEnable()) m_network.showErrorDlg("Ʈũ !");
    }

    //Bufäô ϱ
    private final void setChatBuffer(Vector buf)
    {
      for (int i=0; i<buf.size(); i+=4)
      {
        String str = (String)buf.elementAt(i); //room no
        String roomTitle = (String)buf.elementAt(i+1); //title
        String maxUser = (String)buf.elementAt(i+2); //max user
        String passwd = (String)buf.elementAt(i+3); //passwd

        byte roomNo = Byte.parseByte(str);
        m_network.room_number = roomNo;
        //UI
        if (passwd.equalsIgnoreCase("")) //
          Buf_waitting_room.addElement(new ChatRoom(roomNo, roomTitle, ChatRoom.OPEN, Integer.parseInt(maxUser), null));
        else //
          Buf_waitting_room.addElement(new ChatRoom(roomNo, roomTitle, ChatRoom.NOT_OPEN, Integer.parseInt(maxUser), passwd));
      }
    }

    /**
     *  Ŀǵ带 εѴ
     * */
	private final void load()
    {
       //̺ 
       LabelComponent label = new LabelComponent("", img_waitting_room);
       label.setBackground(0x336699);
       label.setForeground(0x396CB6);
       sh.setTitle(label);

       //ڸ
       m_list = new ListComponent(ListComponent.SELECT_IMPLICIT);
       m_list.controlNumber(false);
       center.addComponent(m_list);

       //command bar
       CommandBarComponent cmdBar = new CommandBarComponent();
       cmdBar.addCommand(cmd_before = new Command(this.strCmd_before, img_before, null));
       cmdBar.addCommand(cmd_next = new Command(this.strCmd_next, img_next, null));
       cmdBar.addCommand(cmd_enter_chatting_room = new Command(this.strCmd_enter_chatting_room, img_enter_chatting_room, null));
       cmdBar.addCommand(cmd_make_room = new Command(this.strCmd_make_room, img_make_room, null));
       cmdBar.addCommand(cmd_exit = new Command(this.strCmd_exit, img_exit, null));
       cmdBar.setCommandListener(this, null);
       south.addComponent(cmdBar);

       // ̱
       sh.addComponent(center);
       sh.setCommand(south, false);
       sh.show();
	}

    /**
     * png غ
     * */
    private final boolean imageLoading()
    {
      try
      {
        img_before = Image.createImage("bott_chati02.png");
        img_next = Image.createImage("bott_chati03.png");
        img_enter_chatting_room = Image.createImage("bott_chati04.png");
        img_make_room = Image.createImage("bott_chati05.png");
        img_exit = Image.createImage("bott_chati06.png");

        img_open_room = Image.createImage("left_chat01.png");
        img_close_room = Image.createImage("left_chat02.png");

        img_waitting_room = Image.createImage("title_chat03.png");

        img_request_room = Image.createImage("left_sms01.png");
      }
      catch(Exception e){ return false; }

      return true;
    }

  /**
   * CommandBar ̺Ʈ ó
   * */
  public void commandAction(Command c, int type, Object obj)
  {
    if (m_network.isEnable())
    {
      String cmd = c.getString();

      if (type == 2)
      {
        if (cmd.equalsIgnoreCase(strCmd_before))
        {
          System.out.println("..");
        }
        else if (cmd.equalsIgnoreCase(strCmd_next))
        {
          System.out.println("..");
        }
        //äù
        else if (cmd.equalsIgnoreCase(strCmd_enter_chatting_room))
        {
          if (SelectedKey > 0)
          {
            //й  ȣ
            if (IsOpen == ChatRoom.NOT_OPEN)
            {
              if (this.SelectedInvite) //ʴ  ȣ  ʴ´
              {
                 //äù濡 α
                 m_network.chat_login(Byte.parseByte(String.valueOf(SelectedKey)));
                 sendRejectMsg(); //ʴ 鿡Դ ʴ ޼ 
              }
              else
              {
                CyementTextField tfPasswd = new CyementTextField(null, TextComponent.CONSTRAINT_PASSWORD);
                tfPasswd.setMaxLength(20);

                DialogComponent dc = new DialogComponent(DialogComponent.TYPE_OK_CANCEL);
                dc.addComponent(tfPasswd);
                dc.setTitle("йȣ");
                tfPasswd.setFocus();
                int ret = dc.doModal();
                if (ret == DialogComponent.DLG_OK && tfPasswd.getString() != null)
                { //
                  if (tfPasswd.getString().equalsIgnoreCase(SelectedPasswd))
                  {
                    //äù濡 α
                    m_network.chat_login(Byte.parseByte(String.valueOf(SelectedKey)));
                    sendRejectMsg(); //ʴ 鿡Դ ʴ ޼ 
                  }
                  else
                  {
                    DialogComponent caution = new DialogComponent(
                            new LabelComponent("ȣ Ʋϴ!"),
                            "",
                            DialogComponent.TYPE_NONE);
                    caution.setTimeout(1*1000);
                    caution.show();
                  }
                }
              }
            }
            else //
            {
              //äù濡 α
              m_network.chat_login(Byte.parseByte(String.valueOf(SelectedKey)));
              sendRejectMsg();
            }
          }
          else
          {
            if (m_list.getImage(0) == null)
            {
               DialogComponent caution = new DialogComponent(
                            new LabelComponent("äù \n ʽϴ !"),
                           "",
                           DialogComponent.TYPE_NONE);
               caution.setTimeout(1*1000);
               caution.show();
            }
            else
            {
               DialogComponent caution = new DialogComponent(
                            new LabelComponent("ȭ  \nϼ !"),
                           "",
                           DialogComponent.TYPE_NONE);
               caution.setTimeout(1*1000);
               caution.show();
            }
          }
        }
        // äù 
        else if (cmd.equalsIgnoreCase(strCmd_make_room))
        {
          NewRoom äù游 = new NewRoom(sh, m_network);
        }
        //ùȭ ư
        else if (cmd.equalsIgnoreCase(strCmd_exit))
        {
          //MainCmp α׷   ̷
          MainCmp äø = new MainCmp(sh, m_network);
        }
      }
    }
  }

  /**
   * α  ̾α ֱ
   * */
    /*
      Ʒθ   ׿ 
          Ʒθ :
          DialogComponent 
           ׿  Main Thread   ϰ ֽϴ.
      ̾α׸  ʽϴ
    */
  public final void showLoginFailDlg()
  {
    /*
    DialogComponent caution = new DialogComponent(
            new LabelComponent(" α !"),
            "",
            DialogComponent.TYPE_NONE);
    caution.setTimeout(1*1000);
    caution.show();
    */
    System.out.println("StandbyRoom.showLoginFailDlg().α  !");
  }

  /**
   * äù 
   * */
  public final void enterChatRoom()
  {
    //äù 
    Chat äù = new Chat(sh, m_network, SelectedKey, SelectedTitle);
  }

  /**
   * ä ǿ äù Ʈ ѷֱ
   *
   * @param buf äù Ʈ
   */
  public final void setChatRoomList(Vector buf)
  {
    m_list.removeAllComponents();
    Buf_waitting_room.removeAllElements();
    setChatBuffer(buf); //äù Ʈ ʱȭ

    if (Buf_waitting_room.size() > 0)
    {
      //äô ε
      for (int i=0; i<Buf_waitting_room.size(); i++)
      {
        ChatRoom room = (ChatRoom)Buf_waitting_room.elementAt(i);
        String title = room.getTitle();
        int isOpen = room.isOpen();
        int max = room.getMax();

        if (isOpen == ChatRoom.OPEN)
            m_list.append(title, img_open_room);
        else
            m_list.append(title, img_close_room);
      }

      //Ʈ ù° ׻ 
      m_list.select(0);
      m_list.setActionListener(this, m_list);
    }
    else
    {
      center.removeAllComponents();
      ListItemComponent lic = new ListItemComponent(" äù ϴ !");
      m_list.addComponent(lic);
      m_list.select(lic);
      center.addComponent(m_list);
    }
  }

  /**
   * ListComponent ׼ ó
   * */
  public void action(Component c, Object o)
  {
    if (m_network.isEnable())
    {
      ListComponent list = (ListComponent)o;
      //Ʈ õ ε 
      int selectedIdx = list.getSelectedIndex();
      // õ ä 
      ChatRoom room = (ChatRoom)Buf_waitting_room.elementAt(selectedIdx);
      SelectedKey = room.getKey();
      SelectedTitle = room.getTitle();
      SelectedPasswd = room.getPasswd();
      SelectedInvite = room.getInviteValue();
      IsOpen = room.isOpen();
    }
  }

  /**
   * û޼ ֱ
   * */
  public final void showInviteMessage(byte inviteRoomNo)
  {
      for (int i=0; i<Buf_waitting_room.size(); i++)
      {
        ChatRoom room = (ChatRoom)Buf_waitting_room.elementAt(i);
        String strKey = room.getStrKey();
        byte key = Byte.parseByte(strKey);

        if (key == inviteRoomNo)
        {
          m_list.set(i, room.getTitle(), img_request_room); //ʴ Ʈ 
          room.setInviteValue(true); //äù ۳ ʴ޾ 
        }
      }
  }

  /*
    õ  äù濡 ʴ ޼ 

    1. SelectedKey ʴ ƴҰ
      Bufäô  ִ ʴ  濡 Reject ޼ 
    2. SelectedKey ʴ 
      SelectedKey濡 ʴ ϱ ޼ 
      SelectedKey  Bufäô  ִ ʴ  濡 Reject ޼ 
  */
  private final void sendRejectMsg()
  {
    if (SelectedInvite) //ʴ 
    {
      //ʴ  ޼ 
      for (int i=0; i<Buf_waitting_room.size(); i++)
      {
        ChatRoom room = (ChatRoom)Buf_waitting_room.elementAt(i);
        byte roomNo = Byte.parseByte(room.getStrKey().trim());
        if (room.getInviteValue())
        {
          if (roomNo != SelectedKey)
          {
            //ʴ
            m_network.sendRejectMessage(roomNo);
          }
        }
      }
    }
    else //ʴ ƴҰ
    {
      //ʴ濡 Ͽ ʴ  ޼ 
      for (int i=0; i<Buf_waitting_room.size(); i++)
      {
        ChatRoom room = (ChatRoom)Buf_waitting_room.elementAt(i);
        if (room.getInviteValue())
        {
          byte roomNo = Byte.parseByte(room.getStrKey().trim());
          //ʴ
          m_network.sendRejectMessage(roomNo);
        }
      }
    }
  }

}
