package wipi_book_network;

import org.kwis.msp.lcdui.*;
import org.kwis.msp.lwc.*;
import org.kwis.msf.io.*;
import org.kwis.msp.db.*;
import org.kwis.msp.io.*;


import java.io.*;
import java.lang.*;


public class TicTacToeClient extends Jlet implements ImageObserver{

    //ȭ  
    Display display = null ;
    MyCard card = null ;
    Image image_back = null ;
    Image image_panel = null ;
    Image image_O = null ;
    Image image_X = null ;

    //  Ʈ
    DataInputStream dis = null ;
    DataOutputStream dos = null ;

    //Ŭ ڵ
    TTTgame game = new TTTgame();
    //Ʈ  ڵ
    ListenThread  net = null ;

    // Ʈ  Ҷ 
    boolean on_stop_request = false ;

    /**
     * .
     */
    public TicTacToeClient() {
    }

    protected void destroyApp(boolean parm1) {
        /**@todo: implement this org.kwis.msp.lcdui.Jlet abstract method*/
    }
    protected void startApp(String[] parm1) {
        /**@todo: implement this org.kwis.msp.lcdui.Jlet abstract method*/
        AnnunciatorComponent m_anc = new AnnunciatorComponent(false) ;
        m_anc.show();
        try{ image_panel = Image.createImage("tictactoe_panel.png" );      }catch(Exception e){}
        try{ image_O = Image.createImage("tictactoe_O.gif" );      }catch(Exception e){}
        try{ image_X = Image.createImage("tictactoe_X.gif");      }catch(Exception e){}
        try{ image_back = Image.loadImage("tictactoe_back.png" , this);      }catch(Exception e){}
    }


    // ̹  ҷ  ̹  ȣѴ.
    public void notify(Image p0, int p1){
        draw();
    }

    /**
     * Card  stack ִ´.
     */
    private void draw(){
        display = Display.getDefaultDisplay();
        display.pushCard(new StartCard());
    }

    /**
     * ſ  Ѵ.
     */
    private void initSocket(){
        try
        {
          int ret = Network.connect();
          if (ret != -1)
          {
            try{
                Socket socket = (Socket) URL.find("socket://127.0.0.1:5002") ;
                dis = new DataInputStream(socket.getInputStream());
                dos = new DataOutputStream(socket.getOutputStream());
            }catch(Exception e){
                System.out.println("   ϴ. "+e.getMessage());
            }
          }else
          {
                System.out.println("ͳ    ϴ.");
          }
        }catch(Exception e){
            System.out.println("ͳ ʱȭ   ϴ. ");
        }

        net = new ListenThread();
        net.start();
    }



    /**
     * ʱ  ȭ ִ Ŭ
     */
    class StartCard extends Card{
        public StartCard(){
            super(true);
        }
        public void paint(Graphics g){
        System.out.println("");
            // ʱ⿡ ع ׸ϴ.
            g.setColor(0);
            g.drawImage(image_back,10,10,g.LEFT);
            g.drawString("  ƹŰ ", 0,100,g.LEFT);
        }
        // ƹŰ  ȭ  ȭ ̵Ѵ.
        public boolean  keyNotify(int type, int key){
            display.popCard();
            card = new MyCard();
            display.pushCard(card);
            initSocket();
            return false ;
        }
    }


    /**
     *  ȭ ׷ִ Ŭ
     */
    class MyCard extends Card {

        String svrmsg1 = null ;
        String svrmsg2 = null ;
        String winermsg = null ;

        public MyCard(){
            super(true);
        }

        public void paint(Graphics g){
            // ʱ⿡ ع ׸ϴ.
            g.setColor(0xFFFFFF);
            g.fillRect(0, 0, getWidth(), getHeight());
            g.setColor(0);
            g.drawImage(image_panel,20,0, g.LEFT);

            // O , X ׸
            for(int i = 0 ; i <  9 ; i++){
                int x = game.getX(i)+20;
                int y = game.getY(i);
                if(game.columns[i] == 0) continue ;
                else if(game.columns[i] == 1)
                    g.drawImage(image_O,x,y,g.LEFT);
                else if(game.columns[i] == 2)
                    g.drawImage(image_X,x,y,g.LEFT);
            }

            //簢 Ŀ ׸
            if(game.m_gameMyturn){
                int x = game.getX(game.rectpos) + 20;
                int y = game.getY(game.rectpos);
                g.drawRect(x,y,24,24) ;
            }

            //  ޼ Ѹ.
            if(game.isWin == 1) {
                g.setColor(0xdddddd);
                g.fillRect(0,37,getWidth(),70);
                g.setColor(0);
                g.drawRect(0,37,getWidth()-1,70);
                g.drawString("ӿ ̰ϴ",5,40,g.LEFT);
                g.drawString("Ͻ÷ " ,5,55,g.LEFT);
                g.drawString("Ȯ ",5,70,g.LEFT);
                g.drawString(game.getRankString(),5,85,g.LEFT);
            }else if(game.isWin == 2) {
                g.setColor(0xdddddd);
                g.fillRect(0,37,getWidth(),70);
                g.setColor(0);
                g.drawRect(0,37,getWidth(),70);
                g.drawString("ӿ ϴ",5,40,g.LEFT);
                g.drawString("Ͻ÷ " ,5,55,g.LEFT);
                g.drawString("Ȯ ",5,70,g.LEFT);
                g.drawString(game.getRankString(),5,85,g.LEFT);
            }else if(game.isWin == 3) {
                g.setColor(0xdddddd);
                g.fillRect(0,37,getWidth(),70);
                g.setColor(0);
                g.drawRect(0,37,getWidth(),70);
                g.drawString("ϴ.",5,40,g.LEFT);
                g.drawString("Ͻ÷ " ,5,55,g.LEFT);
                g.drawString("Ȯ ",5,70,g.LEFT);
                g.drawString(game.getRankString(),5,85,g.LEFT);
            }else {
                g.drawString(svrmsg1,5,getHeight()-30,g.LEFT);
                g.drawString(svrmsg2,5,getHeight()-18,g.LEFT);
            }
        }

        /**
         *  Ű ̺Ʈ óϴ ޼ҵ
         * @param type ̺Ʈ Ÿ
         * @param key   Ű
         * @return
         */
        public boolean  keyNotify(int type, int key){
            // ̰
            if(game.m_gameMyturn){
                if(type == EventQueue.POINT_RELEASED){
                    switch(Display.getGameAction(key)){
                        case EventQueue.UP :
                            if( (game.rectpos - 3) > -1 )
                                 game.rectpos -= 3;
                            break;
                        case EventQueue.DOWN :
                            if( (game.rectpos + 3) < 9)
                                 game.rectpos += 3;
                            break;
                        case EventQueue.RIGHT :
                            if( ((game.rectpos + 1)/3) == game.rectpos /3 )
                                 game.rectpos += 1;
                            break;
                        case EventQueue.LEFT :
                            if( ((game.rectpos - 1)/3)  == game.rectpos /3 )
                                 game.rectpos -= 1;
                            break;
                        case EventQueue.FIRE :
                            if(game.isWin != 0){
                                System.out.println("isWin ="+game.isWin);
                                sendMsg(dos ,(TTTProtocol.M_NEWGAME+":-").getBytes());
                                game.newGame();
                            }else {
                                if(game.columns[game.rectpos] != 0 ){
                                    card.svrmsg1 = "ٲܼ ϴ";
                                    break;
                                }
                                game.m_gameMyturn = false;
                                sendMsg(dos ,(TTTProtocol.M_SELECT+":"+game.rectpos).getBytes());
                                game.setValue(game.rectpos,1);
                                svrmsg1 = "ٸ";

                            }
                                break;
                        case EventQueue.CLEAR :
                            game.exit();
                                break;
                        case EventQueue.SOFT1 :
                             break;
                    }
                    repaint();
                    card.svrmsg2 = "" ;
                }
            }
            //ʰ ƴѰ ó
            else {
                if(game.isWin != 0){
                    System.out.println("isWin ="+game.isWin);
                    sendMsg(dos ,(TTTProtocol.M_NEWGAME+":-").getBytes());
                    game.newGame();
                }
            }

            return false ;
        }

   }


    /**
     *   Ÿ д  ϴ 
     */
    class ListenThread extends Thread  {

        String sendingMsg = null ;

        byte[] readdata = null;

        /**
         *  
         */
        public void run(){
            System.out.println(" ...");

            try{
                while(!on_stop_request) {
                    System.out.println(" ϰ ִ...");
                    byte[]	buf		=	new byte[10];
                    String	temp	=	"";
                    int		size	=	0;
                    if(sendingMsg!=null)
                        dos.write(sendingMsg.getBytes());
                    sendingMsg = null ;

                    int len  = dis.read(buf,0,10);

                    String s_len = (new String(buf,0,len)).trim();
                    temp = new String(getNetworkData(dis,Integer.parseInt(s_len)));
                    System.out.println("   : " + temp);
                    int idx	=	temp.indexOf(":");
                    if(idx < 0) continue;
                    String cmd	=	temp.substring(0, idx);
                    String data	=	temp.substring(idx + 1);
                    routine(cmd, data);
                }
            }catch(Exception e){}

        }

        /**
         *    Ѵ.
         * @param cmd  ޼ ڵ
         * @param data 
         * @throws Exception
         */
        public void routine(String cmd, String data ) throws Exception {
            System.out.println("CMD : " + cmd + " / " + data);

            if(cmd.equals(TTTProtocol.M_GAMESTART)) {
                game.gameStart(data);
            } else if(cmd.equals(TTTProtocol.M_BUDDYLEFT_WAITING)) {
                game.gameWaiting(data, true);
            } else if(cmd.equals(TTTProtocol.M_BUDDYFIND)) {
                game.gamebuddyFind(data);
            } else if(cmd.equals(TTTProtocol.M_BUDDYWAITING)) {
                game.gameWaiting(data, false);
            } else if(cmd.equals(TTTProtocol.M_SELECT)) {
                game.gameSelect(data);
            } else if(cmd.equals(TTTProtocol.M_NEWGAME)) {
                game.newGame();
            }
        }
    }


    /**
     * 뿡 ͸ ϴ ޼ҵ
     * @param os  ½Ʈ
     * @param data  
     */
    public static void sendMsg( OutputStream os  , byte[] data){

        String temp	=	("" + data.length + "                 ").substring(0, 10);
        String datastr = new String(data);
        try{
            os.write((temp+datastr).getBytes());
            os.flush();
        }catch(Exception e){}
    }

    /**
     * ͸ Է½Ʈ  о ̳.
     * @param is  ޾Ƶ Է½Ʈ
     * @param size   ũ
     * @return       
     * @throws Exception
     */
    public byte[] getNetworkData(InputStream is, int size) throws Exception {
        byte[]	buf		=	null;
        byte[]	result	=	new byte[size];

        int		len	=	0;
        int		total	=	0;
        int		t_size	=	0;

        while(!on_stop_request) {
            buf		=	new byte[t_size];
            len		=	is.read(buf, 0, buf.length);
            System.arraycopy(buf, 0, result, total, len);

            total	+=	len;
            if(total == size) break;
            t_size	=	size - total;
        }
        return result;
    }

    /**
     *  ǥϴ Ŭ
     */
    class TTTgame {

        //  Į   Ǿ .
        int [] columns = new int[9];

        // Ŀ ġ
        int rectpos  = 0;

        // : true :  , false :  
        boolean m_gameMyturn = false ;

        /**
         * 0:, 1:̱ , 2: 
         */
        int isWin = 0 ;

        //·
        int wincnt = 0 ;
        int losecnt = 0 ;
        int drawcnt = 0 ;

        // ̽
        RecordData recorddata = null ;


        public TTTgame(){
            initRankData();
        }


        /**
         * ͺ̽  ŷ͸ о´.
         */
        private void initRankData(){
            try{
                DataBase db = DataBase.openDataBase("rankdata",30,true, FileSystem.PRIVATE_ACCESS);
                int cnt = db.getNumberOfRecords();
                System.out.println("DBcnt =" + cnt);
                if(cnt == 0 ){
                    recorddata = new RecordData(0,0,0);
                    db.insertRecord(recorddata.toByte());
                }else {
                    byte[] data = db.selectRecord(0);
                    RecordData recorddata = new RecordData(data);
                    wincnt = Integer.parseInt(recorddata.win);
                    losecnt = Integer.parseInt(recorddata.lose);
                    drawcnt = Integer.parseInt(recorddata.draw);
                }
            }catch(Exception e){
                System.out.println("DBERROR");
            }

        }

        /**
         * ο  
         */
        private void newGame(){
            columns = new int[9];
            isWin = 0;
            rectpos = 0 ;
            card.repaint();
        }

        /**
         *  O , X õǾ.
         * @param index õ ġ
         * @param value  ü 1 : , 2 :
         */
        private void setValue(int index , int value ){
            columns[index] = value;
            if(isFinished()){
                if( isWin == 1 ) wincnt++;
                else if( isWin == 2  ) losecnt++;
                else if( isWin  == 3 ) drawcnt ++;
                recorddata = new RecordData(wincnt , losecnt , drawcnt);
                recorddata.toDB();
            }
        }

        /**
         *   ˻.
         * @return
         */
        private boolean isFinished(){

            if( columns[0] == columns[1]&& columns[1] == columns[2] ) {
                isWin = columns[0] ;
                return true;
            }
            if( columns[3] == columns[4] && columns[4] == columns[5] ) {
                isWin = columns[3] ;
                return true;
            }
            if( columns[6] == columns[7]  && columns[7]== columns[8] ) {
                isWin = columns[6] ;
                return true;
            }

            if( columns[0] == columns[3] && columns[3] == columns[6] ) {
                isWin = columns[0] ;
                return true;
            }
            if( columns[1] == columns[4] && columns[4] == columns[7] ) {
                isWin = columns[1] ;
                return true;
            }
            if( columns[2] == columns[5] && columns[5]== columns[8] ) {
                isWin = columns[2] ;
                return true;
            }

            if( columns[0] == columns[4] && columns[4] == columns[8] ){
                isWin = columns[0] ;
                return true;
            }

            if( columns[2] ==  columns[4]  && columns[4] == columns[6] ) {
                isWin = columns[3] ;
                return true;
            }

            int i = 0;
            for(i = 0 ; i <  9 ; i++){
                if(columns[i] == 0){
                    i = -1 ;
                    break;
                }
            }
            if(i == 9){
                isWin = 3;
                return true ;
            }

            return false ;
        }

        /**
         *  xǥ
         * @param index  ġ
         * @return
         */
        private int getX(int index){
            //3, 29, 54
            int col = index%3 ;
            return  3 + 24*col ;
        }

        /**
         *  y ǥ
         * @param index ׷  ġ
         * @return
         */
        private int getY(int index){
            //3, 29, 54
            int col = index/3 ;
            return  3 + 24*col ;
        }

        /**
         *   Ѵ.
         * @param data
         */
        private void gameStart(String data){
            System.out.println("data ="+data);
            game.newGame();
            if(data.equals("TRUE")){
                m_gameMyturn = true;
                card.svrmsg1 = " մϴ. " ;
                card.svrmsg2 = "ν Դϴ." ;
            }else{
                m_gameMyturn = false ;
                card.svrmsg1 = " մϴ. " ;
                card.svrmsg2 = "ļ Դϴ." ;
            }

            card.repaint();
        }

        /**
         * 밡 ö  ٸ.
         * @param data
         * @param which  밡 ߿  , ƴ óͼ 
         */
        private void gameWaiting(String data, boolean which){
            m_gameMyturn = false ;
            if(which){
                card.svrmsg1 = " ϴ." ;
                card.svrmsg2 = "븦 ٸϴ." ;
            }else{
                card.svrmsg1 = "븦 ٸ" ;
                card.svrmsg2 ="Դϴ" ;
            }
            card.repaint();
        }

        /**
         * 밡 ξ.
         * @param data
         */
        private void gameSelect(String data){
            card.svrmsg1 = "νԴϴ." ;
            card.svrmsg2 = "";
            game.m_gameMyturn = true;
            int selectedcol =  Integer.parseInt(data);
            setValue(selectedcol,2);
            card.repaint();
        }

        /**
         * · Ʈ ´.
         * @return
         */
        private String getRankString(){
            return wincnt+" "+losecnt+" "+drawcnt+"" ;

        }

        /**
         *   ִ ´.
         * @param data
         */
        private void gamebuddyFind(String data){
            sendMsg(dos,(TTTProtocol.M_BUDDYFIND+":-").getBytes());
        }


        private void exit(){

        }

    }

    /**
     * ̽  Ŭ
     */
    class RecordData {
        public String win ;
        public String lose ;
        public String draw ;

        /**
         * ̱,  ,  Ƚ  ü Ѵ.
         * ڷκ Է¹ ͸  ü Ҷ 
         * @param win
         * @param lose
         * @param draw
         */
        public RecordData( int win , int lose, int draw){
            this.win =  ""+win ;
            this.lose = ""+lose ;
            this.draw = ""+draw ;
        }

        /**
         * ͺ̽  ڵ带  ü
         * @param data
         */
        public RecordData(byte[] data){
            // ̱Ƚ
            byte[] bytes = new byte[10];
            System.arraycopy(data,0, bytes,0,10);
            win = new String(bytes).trim();
            // Ƚ
            bytes = new byte[10];
            System.arraycopy(data,0, bytes,0,10);
            lose = new String(bytes).trim();
            //  Ƚ
            bytes = new byte[10];
            System.arraycopy(data,0, bytes,0,10);
            draw = new String(bytes).trim();

        }

        /**
         * ü  byte 迭 ٲ۴.
         * @return
         */
        public byte[] toByte(){
            byte[] data = null ;
            try{
                ByteArrayOutputStream baos = new ByteArrayOutputStream();
                DataOutputStream dos = new DataOutputStream(baos);
                dos.write((win+"           ").substring(0,10).getBytes());
                dos.write((lose+"           ").substring(0,10).getBytes());
                dos.write((draw+"           ").substring(0,10).getBytes());
                data = baos.toByteArray();
                baos.close();
                dos.close();
            }catch(Exception e){      }
            return data ;
        }

        /**
         * ͺ̽ .
         */
        public void toDB(){
            try{
                DataBase db = DataBase.openDataBase("rankdata",30,true, FileSystem.PRIVATE_ACCESS);
                db.updateRecord(1,toByte());
            }catch(Exception e){
            }
        }
    }
}