public class DwCommon {
	public static void Debug(String s) {
		System.out.println(s);
	}
	
	public static void Debug(Throwable t) {
		t.printStackTrace();
	}

	/**
	 * Array ó  Լ Set
	 */
 	public int indexOfArray(String[] data, String name) {
		if(data == null || name == null) return -1;
		
		for(int i=0; i < data.length; i++) {
			if(data[i].equals(name)) return i;
		}
		
		return -1;
	}

	public static String[] addArray(String[] data, String s) {
		if(data == null) return new String[] { s };

		String[] tmp	=	new String[data.length + 1];

		System.arraycopy(data, 0,  tmp, 0, data.length);
		tmp[data.length]	=	s;

		return tmp;
	}

	public static String[] removeArray(String[] data, int idx) {
		if(data == null) return new String[] {};

		String[] tmp	=	new String[data.length - 1];

		System.arraycopy(data, 0,  tmp, 0, idx);
		System.arraycopy(data, idx + 1,  tmp, idx, tmp.length - idx);

		return tmp;
	}
}
