import java.util.*;
import java.io.*;
import org.kwis.msp.lwc.*;
import org.kwis.msp.lcdui.*;

public class DwData {
	public final static String	SERVER_STR	=	"socket://211.174.55.168:10000";
//	public final static String	SERVER_STR	=	"socket://127.0.0.1:10000";
	public final static int		COMMAND_SIZE	=	10;
	public final static String	SEARCH_CMD	=	"SEARCH_CMD";
	public final static String	MAP_CMD		=	"MAP_CMD";

	public final static String	SPACE		=	"                    ";
	public final static String	DELI		=	"\b";


	public static ShellComponent		sh			=	null;

	//  ˻(ã  Է)
	public static DwInputField				input_field		=	null;

	//  ˻( )
	public static DwMapList				map_list		=	null;

	// ˻ ( ׸)
	public static DwMapScreen			map_screen	=	null;

	// 
	public static DwHelp					help			=	null;

	public static Hashtable				img_pool		=	null;

	protected static void hideComponent() {
		sh.removeAllComponents();
	}

	public static void showComponent(Component c) {
		hideComponent();

		sh.addComponent(c);
		c.setFocus();
	}

	public static Image getImage(String filename) {
		if(img_pool == null) img_pool	=	new Hashtable();

		Image img	=	(Image)img_pool.get(filename);
		if(img == null) {
			try {
				img		=	Image.createImage(filename);
			} catch (Exception e) {
				return null;
			}

			img_pool.put(filename, img);
		}

		return img;
	}

	/**
	 * Network ش sizeŭ  д´.
	 */
	public static byte[] getNetworkData(InputStream is, int size) throws IOException {
		byte[] buf		=	null;
		byte[] result	=	new byte[size];

		int len	= 0;
		int total	= 0;
		int t_size	= size;

		boolean stop_request	=	false;
		while(!stop_request) {
			buf	=	new byte[t_size];
			len	=	is.read(buf, 0, buf.length);

			System.arraycopy(buf, 0, result, total, len);

			total	+=	len;
			if(total == size) break;
			t_size = size - total;
		}

		return result;
	}

	public static void sendMessage(OutputStream os, String cmd, String data) throws IOException {
		sendMessage(os, cmd, data.getBytes());
	}

	public static void sendMessage(OutputStream os, String cmd, byte[] data) throws IOException {
		cmd			=	("" + cmd + SPACE).substring(0, COMMAND_SIZE);
		String temp	=	("" + data.length + SPACE).substring(0, COMMAND_SIZE);

		os.write(cmd.getBytes());
		os.write(temp.getBytes());
		os.write(data);
		os.flush();
	}
}
